/*
 * File name: Lab07.java
 * Date:      2014/08/27 08:31
 * Author:    @author
 */
package cz.cvut.fel.pr1;

public class Lab07 {

    private static final String LOGFILE = "dat/results-jh-l3r5.log";
    private final TextIO txtIO;

    public Lab07(TextIO txtIO) {
        this.txtIO = txtIO;
    }

    public void start(String[] args) {
        // expected column names METHOD, MNE, DISTANCE, CPUTIME
        // expected methods ga, ia, ha, ma
        // expected values of MNE are from the interval 5..20
        processFile(LOGFILE);
    }

    public void processFile(String filename) {
        txtIO.openFile(filename);
        //print a table with average DISTANCE for each method and MNE
        final String valueColumn = "DISTANCE";
        
        String head = "MNE" + "\t" + "ga" + "\t" + "ia" + "\t" + "ha";
        
        System.out.println(head);
        // txtIO.printToFile("my_file.dat", head);

        for (int mne = 5; mne <= 20; ++mne) {
            String row = mne + "\t"; //use tabular as column separator

            double value = getAvg(mne, "ga", valueColumn);
            row += String.format("%.1f\t", value);

            value = getAvg(mne, "ia", valueColumn);
            row += String.format("%.1f\t", value);

            value = getAvg(mne, "ha", valueColumn);
            row += String.format("%.1f", value);

            System.out.println(row);
            // txtIO.appendToFile("my_file.dat", row);
        }
    }

    public double getAvg(int mne, String method, String valueColumn) {

        double outputValue = 0;
        txtIO.resetFile();

        double avg = 0.0;
        int count = 0;

        while (txtIO.readLine()) {
            String mneValue = txtIO.getColumnValue("MNE");
            String methodValue = txtIO.getColumnValue("METHOD");
            String value = txtIO.getColumnValue(valueColumn);

            // check if the data are available and parseable
            if (mneValue.isEmpty() || methodValue.isEmpty() || value.isEmpty() || !TextIO.isInteger(mneValue) || !TextIO.isDouble(value)) {
                System.err.println("Unable to compute average " + valueColumn + " for METHOD '" + method + "' and MNE '" + mne + "'");
                return Double.NaN;
            }

            // both MNE and METHOD values have to match in the line
            if (Integer.parseInt(mneValue) == mne && methodValue.equals(method)) {
                avg += Double.parseDouble(value);
                count++;
            }
        }

        if (count > 0) {
            outputValue = avg / count;
        }

        return outputValue;
    }
}
